ThunderSVM: A Fast SVM Library on GPUs and CPUs
======================================
The mission of ThunderSVM is to help users easily and efficiently apply SVMs to solve problems. ThunderSVM exploits GPUs and multi-core CPUs to achieve high efficiency. Key features of ThunderSVM are as follows.
* Support all functionalities of LibSVM such as one-class SVMs, SVC, SVR and probabilistic SVMs.
* Use same command line options as LibSVM.
* Support Python, R and Matlab interfaces.
* Supported Operating Systems: Linux, Windows and MacOS.

**Why accelerate SVMs**: A [survey](https://www.kaggle.com/amberthomas/kaggle-2017-survey-results) conducted by Kaggle in 2017 shows that 26% of the data mining and machine learning practitioners are users of SVMs.

<div align="center">
<img src="https://github.com/zeyiwen/thundersvm/raw/master/docs/_static/logo.png" width="220" height="180" align=left/>
<img src="https://github.com/zeyiwen/thundersvm/raw/master/docs/_static/lang-logo.png" width="230" height="180" align=left/>
<img src="https://github.com/zeyiwen/thundersvm/raw/master/docs/_static/overall.png" width="230" height="180" align=left/>
</div>

## More information about ThunderSVM
* [Getting Started](get-started.md)
* [Introduction](intro.md)
* [Parameters](parameters.md)
* [How To](how-to.md)
* [FAQ](faq.md)
* [Related Websites](related-website.md)
